(function () {
    "use strict";

    angular.module('core').controller('gradeController', controller);
    controller.$inject = ['$scope', '$timeout', 'gradeService', '$alert','lookupService', '$q','$state'];

    function controller($scope, $timeout, gradeService, $alert ,lookupService, $q, $state) {
        $scope.initializeLayout('Grades');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: { Ativo: null },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };


        $scope.auxiliar = {
            posicao: {
                prepareNew: function () {
                    $scope.state.vazio = false;
                    gradeService
                        .prepareNewPosicao($scope.state.item)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                $scope.state.item = response.Data;
                            }
                            $scope.state.vazio = !$scope.state.item;
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });
                },
            },
            tipograde: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoGrade({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };
        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            gradeService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.data);
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = ($scope.state.data == 0);
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.count = function () {
            gradeService
                .count($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.count = response.Data;
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            gradeService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    gradeService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) { 
                            if (response.Status < 0) {
                                $scope.state.salvando = false;
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $state.go("state-grade-edit", { id: response.Data.ID });
                                $scope.state.salvando = false;
                            }
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                 
                }
            }
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.filtro.Ativo = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();